CREATE OR REPLACE EDITIONABLE TYPE "SAMPLE"."INTARRAY" AS VARRAY(100) OF NUMBER;

CREATE TABLE "SAMPLE"."HIERARCHY" ("HIERARCHY_ID" NUMBER(19,0), "NAME" VARCHAR2(255 BYTE), "PARENT_ID" NUMBER(19,0)) TABLESPACE "USERS"

CREATE TABLE "SAMPLE"."ITEM" ("ITEM_ID" NUMBER(19,0), "NAME" VARCHAR2(255 BYTE), "HIERARCHY_ID" NUMBER(19,0)) TABLESPACE "USERS"

CREATE OR REPLACE FORCE EDITIONABLE VIEW "SAMPLE"."HIERARCHY_VIEW" ("ANCESTOR", "DESCENDENT") AS SELECT /*+ PUSH_SUBQ PUSH_PRED(h1) */ h1.HIERARCHY_ID ANCESTOR, h2.HIERARCHY_ID DESCENDENT FROM HIERARCHY h1, HIERARCHY h2 WHERE h2.HIERARCHY_ID IN (SELECT h3.HIERARCHY_ID FROM HIERARCHY h3 START WITH h3.HIERARCHY_ID = h1.HIERARCHY_ID CONNECT BY PRIOR h3.HIERARCHY_ID = h3.PARENT_ID)

CREATE UNIQUE INDEX "SAMPLE"."SYS_C003624692" ON "SAMPLE"."HIERARCHY" ("HIERARCHY_ID") PCTFREE 10 INITRANS 2 MAXTRANS 255 STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645 PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT) TABLESPACE "USERS" 

CREATE UNIQUE INDEX "SAMPLE"."SYS_C003624695" ON "SAMPLE"."ITEM" ("ITEM_ID") PCTFREE 10 INITRANS 2 MAXTRANS 255  STORAGE(INITIAL 65536 NEXT 1048576 MINEXTENTS 1 MAXEXTENTS 2147483645 PCTINCREASE 0 FREELISTS 1 FREELIST GROUPS 1 BUFFER_POOL DEFAULT FLASH_CACHE DEFAULT CELL_FLASH_CACHE DEFAULT) TABLESPACE "USERS" 

CREATE OR REPLACE EDITIONABLE FUNCTION "SAMPLE"."IDS_UNDER" (parent_id in number, is_under_type in varchar2) RETURN intarray AS ids intarray := NEW intarray(); query_string varchar2(32000); BEGIN if upper(is_under_type) ='HIERARCHY' then query_string := 'SELECT HIERARCHY_ID FROM HIERARCHY START WITH HIERARCHY_ID = ' || parent_id || ' CONNECT BY PRIOR HIERARCHY_ID = PARENT_ID'; else RETURN ids; end if; execute immediate query_string bulk collect into ids; RETURN ids; exception when others then return null; END;

CREATE OR REPLACE EDITIONABLE FUNCTION "SAMPLE"."IS_UNDER" (parent_id in number, target_id in number, is_under_type in varchar2) RETURN NUMBER AS ids intarray := NEW intarray(); query_string varchar2(32000); answer BOOLEAN; BEGIN query_string := 'SELECT HIERARCHY_ID FROM (SELECT HIERARCHY_ID FROM HIERARCHY START WITH HIERARCHY_ID = ' || target_id || ' CONNECT BY HIERARCHY_ID = PRIOR PARENT_ID) WHERE HIERARCHY_ID = ' || parent_id; execute immediate query_string bulk collect into ids; IF ids.exists(1) THEN return 1; END IF; RETURN 0; EXCEPTION WHEN OTHERS THEN RETURN 0; END;

