package com.example.isUnderPrototype;

import java.util.List;

/**
 * <p>A parameter object for building the "Is Under"
 * predicate clause.</p>
 */
public class IsUnderClause {

    private final Iterable<String> m_path;
    private final Long m_id;

    public IsUnderClause(List<String> path, Long id) {
        m_path = path;
        m_id = id;
    }

    /**
     * <p>The id of the HierarchyEO object that is the ancestor
     * of the items we want.</p>
     */
    public Long getIsUnder() {
        return m_id;
    }

    /**
     * <p>The path from the root to the HierarchyEO object.</p>
     */
    public Iterable<String> getPath() {
        return m_path;
    }

}
