package com.example.isUnderPrototype;

import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import com.example.isUnderPrototype.entity.ItemEO;

/**
 * <p>Builds a {@link Predicate} for usage as an "Is Under"
 * function in dynamically-built JPA Criteria Queries.</p>
 */
public interface IsUnderClauseBuilder {

    /**
     * <p>Returns a predicate that is true if the ItemEO is under
     * the given {@link IsUnderClause#getIsUnder() hierarchy item}.</p>
     *
     * @param root The ItemEO root.
     * @param cb The criteria builder.
     * @param data A parameter object representing the options for the clause.
     * @return A predicate that can be used to chain with other predicates.
     */
    Predicate isUnder(Root<ItemEO> root, CriteriaBuilder cb, IsUnderClause data);

}