package com.example.isUnderPrototype.entity;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.eclipse.persistence.annotations.Cache;
import org.eclipse.persistence.annotations.ReadOnly;
import org.eclipse.persistence.config.CacheIsolationType;

@Entity
@Table(name = "HIERARCHY_VIEW")
@Cache(isolation = CacheIsolationType.SHARED)
@ReadOnly
public class HierarchyViewEO {

    HierarchyViewId id;
    HierarchyEO ancestorJoin;
    HierarchyEO descendentJoin;

    @EmbeddedId
    public HierarchyViewId getId() {
        return id;
    }

    public void setId(HierarchyViewId id) {
        this.id = id;
    }

    @ManyToOne(fetch = FetchType.LAZY, targetEntity = HierarchyEO.class)
    @JoinColumn(name = "ANCESTOR", insertable = false, updatable = false)
    public HierarchyEO getAncestorJoin() {
        return ancestorJoin;
    }

    public void setAncestorJoin(HierarchyEO ancestorJoin) {
        this.ancestorJoin = ancestorJoin;
    }

    @ManyToOne(fetch = FetchType.LAZY, targetEntity = HierarchyEO.class)
    @JoinColumn(name = "DESCENDENT", insertable = false, updatable = false)
    public HierarchyEO getDescendentJoin() {
        return descendentJoin;
    }

    public void setDescendentJoin(HierarchyEO descendentJoin) {
        this.descendentJoin = descendentJoin;
    }

}
