package com.example.isUnderPrototype.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.eclipse.persistence.annotations.Cache;
import org.eclipse.persistence.config.CacheIsolationType;

@Entity
@Table(name = "ITEM")
@Cache(isolation = CacheIsolationType.SHARED)
public class ItemEO {
    Long itemId;
    String name;
    HierarchyEO hierarchy;

    @ManyToOne(fetch = FetchType.LAZY, targetEntity = HierarchyEO.class)
    @JoinColumn(name = "HIERARCHY_ID")
    public HierarchyEO getHierarchy() {
        return hierarchy;
    }

    public void setHierarchy(HierarchyEO hierarchy) {
        this.hierarchy = hierarchy;
    }

    @Id
    @Column(name = "ITEM_ID")
    public Long getItemId() {
        return itemId;
    }

    public void setItemId(Long itemId) {
        this.itemId = itemId;
    }

    @Column(name = "NAME")
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

}
