package com.example.isUnderPrototype.impls;

import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaBuilder.In;
import javax.persistence.criteria.Expression;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import org.eclipse.persistence.internal.jpa.querydef.FunctionExpressionImpl;
import org.eclipse.persistence.internal.jpa.querydef.InImpl;
import org.eclipse.persistence.internal.jpa.querydef.SubQueryImpl;

import com.example.isUnderPrototype.IsUnderClause;
import com.example.isUnderPrototype.entity.ItemEO;

/**
 * <p>This approach uses a function called "IDS_UNDER", which
 * returns a VARRAY of ids (NUMBER).</p>
 *
 * <p>This approach uses a {@link FunctionExpressionImpl} as an
 * argument to the {@link In#value(Expression)} method. This
 * is currently unsupported, but is patched in this project.
 * The patch has to be turned on with the "usePatch" System
 * property. The patch simply checks before casting to a
 * {@link SubQueryImpl} in
 * {@link InImpl#value(Expression) InImpl.value()}.</p>
 *
 * <p>I doubt that this method actually works because the
 * INTARRAY type we define and use is limited to 100 items.
 * Needs futher testing.</p>
 */
public class UsingIdsUnderFunction extends BaseIsUnderClauseBuilder {

    @Override
    public Predicate isUnder(Root<ItemEO> root, CriteriaBuilder cb, IsUnderClause data) {
        @SuppressWarnings("rawtypes")
        Expression fn = cb.function("IDS_UNDER", Object.class,
                cb.literal(data.getIsUnder()),
                cb.literal("HIERARCHY"));
        fn = cb.function("TABLE", Object.class, fn);
        fn = cb.function("SELECT * FROM ", Object.class, fn);
        @SuppressWarnings("unchecked")
        Expression<Long> casted = fn;
        return cb.in(pathToHierarchyId(root, data)).value(casted);
    }
}